
// serial demo by lisper 2013-11-19
//    class SerialOpen (int x, int y)


//import controlP5.*;
import processing.serial.*;

//PImage back_img;
//PrintWriter output;

//ControlP5 cp5;  //
SerialOpen serialOpen; //class


int backWidth = 800;
int backHeight = 700;

int servoNum = 24;


int waveMin = 500;
int waveMax = 2500;

float angleMin = 0;
float angleMax = 180.0;


//
void controlEvent (ControlEvent theEvent) {
    //println (theEvent.getName());
    // println (theEvent.getId());
    int id = theEvent.getId ();

    if (id >= 0 && id <= 23 && serialOpen.myPort != null) {
        //println (myPort, id, int(theEvent.getValue()));
      //  serialOpen.cmd_send (id, theEvent.getValue());
    }
    else if (id == ServoId.OPEN_BUTTON) {//serial button
        serialOpen.process ();
    }
}


//
public class SerialOpen {
    Object superclass;
    private ControlP5 cp5;
    private int x;
    private int y;
    public Serial myPort;
    public DropdownList serialList;
    public DropdownList baud_select;
    public Button update_button;
    public Button open_button ;
    public boolean isSerialOpen;

    private int baud_rate = 9600;

    private String baud_list[] = {
        "300", "1200", "2400", "4800", "9600", "14400", "19200", "28800", "57600", "115200", "1000000"
    };
    private int baud_int_list[] = {
        300, 1200, 2400, 4800, 9600, 14400, 19200, 28800, 57600, 115200, 1000000
    };

    public SerialOpen (Object myclass, ControlP5 cp5, int x, int y) {
        this.cp5 = cp5;
        this.x = x;
        this.y = y;
        superclass = myclass;
        //serialNum = myPort.list().length;    //get available serial number
        CreateButton (x, y);
        isSerialOpen = false;
    }

    //
    public void CreateButton (int x, int y) {
        open_button = this.cp5.addButton ("open")
            .setPosition (x, y-21)
                .setColorBackground (color (80, 80, 80))
                    .setId (ServoId.OPEN_BUTTON)
                        .setSize (40, 20);
        //serial dropdownlist
        serialList = this.cp5.addDropdownList("serial")
            .setPosition(x+50, y)
                //.setBackgroundColor(color(190))
                .setColorBackground (color (80, 50, 80))
                    .setItemHeight(20)
                        .setBarHeight(20)
                            .setHeight (30)
                                .setSize (40, 50);
        baud_select = this.cp5.addDropdownList ("baud")
            .setPosition (x+100, y)
                .setColorBackground (color (0, 50, 100))
                    .setItemHeight(15)
                        .setBarHeight(20)
                            .setHeight (10)
                                .setSize (50, 50);

        for (int i=0 ;i<myPort.list ().length; i++) {
            serialList.addItem(myPort.list()[i], i);    //add serial name to serialList
        }
        for (int i=0; i<baud_list.length; i++) {
            baud_select.addItem (baud_list[i], i);
        }
        if (myPort.list().length > 0) {
            serialList.setLabel (myPort.list()[0]);
        }
        serialList.setValue (0);
        baud_select.setValue (4);
    }

    //////////////////////////////////////
    public void process () {
        if (myPort.list ().length  > 0) {  
            if (isSerialOpen) {
                myPort.stop ();
                isSerialOpen = false;
                open_button.setLabel ("open");   
                open_button.setColorBackground (color (80, 80, 80)); 
                println (myPort.list()[int(serialList.getValue())]+" is closed");
            }  
            else {
                myPort = new Serial (RGB_Serial_Tool.this, 
                        Serial.list()[int(serialList.getValue())], 
                        baud_int_list[int(baud_select.getValue())]); // open serial
                if (myPort != null) { 
                    isSerialOpen = true;
                    open_button.setLabel ("close");
                    open_button.setColorBackground (color (0, 150, 0)); 
                    // open_button.setforeColor (0);
                    println (myPort.list()[int(serialList.getValue())]+" is opened");
                } 
                else {
                    println ("error! can't open serial port!");
                }
            }
        } 
        else {
            println ("no available serial port!");
        }
    }

    // command send to serial port
    public void cmd_send (String clor, int angle) {
        int value = angle;
        myPort.write (clor+value);
        println (clor+value+"\r");
    }

//    //angle(0~180) to value(500~2500)
//    private int angle_value (float angle) {
//        return int((waveMax-waveMin) * angle / (angleMax-angleMin) + waveMin);
//    }
}


//
static class ServoId {
    static int OPEN_BUTTON = 1000;
    static int SERVOID []  = {
        0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23
    };
}
